petsc-3.13.6 2020-09-29
Report Typos and Errors

# TaoSoftThreshold

Calculates soft thresholding routine with input vector and given lower and upper bound and returns it to output vector.

### Synopsis

    #include "petsctao.h"
    PetscErrorCode TaoSoftThreshold(Vec in, PetscReal lb, PetscReal ub, Vec out)

### Input Parameters

| in | - input vector to be thresholded
| lb | - lower bound
| ub | - upper bound

### Output Parameters

out -Soft thresholded output vector

### Notes

Soft thresholding is defined as \[ S(input,lb,ub) = \begin{cases} input - ub \text{input > ub} \\ 0 \text{lb =< input <= ub} \\ input + lb \text{input < lb} \\ \]

### Level

developer

### Location

src/tao/util/tao_util.c

### Examples

src/tao/constrained/tutorials/tomographyADMM.c.html
src/tao/tutorials/ex4.c.html
Index of all Tao routines
Table of Contents for all manual pages
Index of all manual pages